program Farma;
uses sysutils,math;
var
    N,K,i,j,m,levo,desno,gore,dole,broj,resenje:longint;
    a:array[1..2000, 1..2000] of longint;
begin
    resenje:=0;
    read(N);
    readln(K);
 
    for j:=1 to N do
    begin
        for i:=1 to (N-1) do
        begin
        read(a[i,j])
        end;
        readln(a[N,j])
    end;
    
for m:=1 to k do
begin
    broj:=0;
    levo:=n+1;
    desno:=0;
    gore:=n+1;
    dole:=0;
    for j:=1 to N do
        for i:=1 to N do
            begin
            if a[i,j] = m then
                begin
                levo:=min(levo,i);
                desno:=max(desno,i);
                gore:=min(gore,j);
                dole:=max(dole,j);
                broj:=broj+1;
                end;
            end;
  if (broj>0) and (broj=(desno-levo+1)*(dole-gore+1)) then
      resenje:=resenje+1;
end;
write(resenje);    
end.